﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Text;
public partial class Add_CollItem : System.Web.UI.Page
{
    Zxq.Bll.CollItem CollItem_Bll = new Zxq.Bll.CollItem();
    Zxq.Model.CollItem CollItem_Model = new Zxq.Model.CollItem();
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            PlAdd.Visible = false;
            PlList.Visible = false;
            PlLink.Visible = false;
            PlContent.Visible = false;
            PlTest.Visible = false;
            PlDataList.Visible = false;
            string Action = Request.QueryString["action"];
            switch (Action)
            {
                case "add":
                    PlAdd.Visible = true;
                    BiudTree();
                    break;
                case "list":
                    PlList.Visible = true;
                    setList();
                    break;
                case "link":
                    PlLink.Visible = true;
                    setLink();
                    GetTest(0);
                    break;
                case "content":
                    PlContent.Visible = true;
                    setContent();
                    GetTest(1);
                    break;
                case "test":
                    PlTest.Visible = true;
                    GetTest(2);
                    break;
                case "start":
                    GetTest(3);
                    break;
                default:
                    PlDataList.Visible = true;
                    GetCollItemList();
                    break;
            }
        }
    }
    private int Id
    {
        get
        {
            if (Request.QueryString["id"] == null)
                return 0;
            return Convert.ToInt32(Request.QueryString["id"]);
        }
    }
    protected void BtnAdd_Click(object sender, EventArgs e)
    {
        CollItem_Model.ItemName = this.TxtItemName.Text;
        CollItem_Model.ClassId = Convert.ToInt32(this.DdlClass.SelectedValue);
        CollItem_Model.WebEncode = this.DdlEndoce.SelectedValue;
        CollItem_Model.WebName = this.TxtWebName.Text;
        CollItem_Model.WebUrl = this.TxtWebUrl.Text;
        CollItem_Model.ItemRemark = this.TxtItemRemark.Text;
        if (this.ChkIframe.Checked)
        {
            CollItem_Model.Script_Iframe = 1;
        }
        if (this.ChkObject.Checked)
        {
            CollItem_Model.Script_Object = 1;
        }
        if (this.ChkScript.Checked)
        {
            CollItem_Model.Script_Script = 1;
        }
        if (this.ChkDiv.Checked)
        {
            CollItem_Model.Script_Div = 1;
        }
        if (this.ChkTable.Checked)
        {
            CollItem_Model.Script_Table = 1;
        }
        if (this.ChkSpan.Checked)
        {
            CollItem_Model.Script_Span = 1;
        }
        if (this.ChkImg.Checked)
        {
            CollItem_Model.Script_Img = 1;
        }
        if (this.ChkFont.Checked)
        {
            CollItem_Model.Script_Font = 1;
        }
        if (this.ChkA.Checked)
        {
            CollItem_Model.Script_A = 1;
        }
        if (this.ChkHtml.Checked)
        {
            CollItem_Model.Script_Html = 1;
        }
        CollItem_Model.CollecNum = Convert.ToInt32(this.TxtCollecNum.Text);
        if (this.ChkSaveImg.Checked)
        {
            CollItem_Model.IsSaveImg = 1;
        }
        if (this.ChkIsDesc.Checked)
        {
            CollItem_Model.IsDesc = 1;
        }
        if (CollItem_Bll.Add(CollItem_Model) > 0)
        {
            int MaxId = CollItem_Bll.GetId();
            Response.Redirect("CollItem.aspx?action=list&id=" + MaxId);
        }
    }

    #region 加载树
    private void BiudTree()
    {
        DataTable Dt;
        Zxq.Bll.Class Class_Bll = new Zxq.Bll.Class();
        Dt = Class_Bll.ClassList();
        this.DdlClass.Items.Clear();
        //加载树
        this.DdlClass.Items.Add(new ListItem("选择分类", ""));
        DataRow[] drs = Dt.Select("ParentId= 0");
        foreach (DataRow r in drs)
        {
            string nodeid = r["Id"].ToString();
            string text = r["ClassName"].ToString();
            string parentid = r["ParentId"].ToString();
            text = "╋" + text;
            this.DdlClass.Items.Add(new ListItem(text, nodeid));
            int sonparentid = int.Parse(nodeid);
            string blank = "　├";
            BindNode(sonparentid, Dt, blank);
        }
        this.DdlClass.DataBind();
    }
    private void BindNode(int parentid, DataTable Dt, string blank)
    {
        DataRow[] drs = Dt.Select("ParentId= " + parentid);
        foreach (DataRow r in drs)
        {
            string nodeid = r["Id"].ToString();
            string text = r["ClassName"].ToString();
            text = blank + "" + text + "";
            this.DdlClass.Items.Add(new ListItem(text, nodeid));
            int sonparentid = int.Parse(nodeid);
            string blank2 = "　　├";
            BindNode(sonparentid, Dt, blank2);
        }
    }
    #endregion

    private void setList()
    {
        Zxq.Model.CollItem model = CollItem_Bll.GetModel(Id);
        if (model != null)
        {
            this.TxtListUrl.Text = model.ListUrl;
            this.TxtListStart.Text = model.ListStart;
            this.TxtListEnd.Text = model.ListEnd;
        }
        else
        {
            Response.Write("<script>alert('没有数据');history.back()</script");
        }
    }
    protected void BtnList_Click(object sender, EventArgs e)//列表
    {
        CollItem_Model.ListUrl = this.TxtListUrl.Text;
        CollItem_Model.ListStart = this.TxtListStart.Text;
        CollItem_Model.ListEnd = this.TxtListEnd.Text;
        CollItem_Model.Id = Id;
        if (CollItem_Bll.UpdateList(CollItem_Model) > 0)
        {
            Response.Write("<script>alert('列表填写完成');window.location='CollItem.aspx?action=link&id=" + Id + "'</script>");
        }
    }
    private void setLink()
    {
        Zxq.Model.CollItem model = CollItem_Bll.GetModel(Id);
        if (model != null)
        {
            this.TxtLinkStart.Text = model.LinkStart;
            this.TxtLinkEnd.Text = model.LinkEnd;
        }
        else
        {
            Response.Write("<script>alert('没有数据');history.back()</script");
        }
    }
    protected void BtnLink_Click(object sender, EventArgs e)
    {
        CollItem_Model.LinkStart = this.TxtLinkStart.Text;
        CollItem_Model.LinkEnd = this.TxtLinkEnd.Text;
        CollItem_Model.Id = Id;
        if (CollItem_Bll.UpdateLink(CollItem_Model) > 0)
        {
            Response.Write("<script>alert('链接填写完成');window.location='CollItem.aspx?action=content&id=" + Id + "'</script>");
        }
    }
    private void setContent()
    {
        Zxq.Model.CollItem model = CollItem_Bll.GetModel(Id);
        if (model != null)
        {
            this.TxtTitleStart.Text = model.TitleStart;
            this.TxtTitleEnd.Text = model.TitleEnd;
            this.TxtKeyWordStart.Text = model.KeyWordStart;
            this.TxtKeyWordEnd.Text = model.KeyWordEnd;
            this.TxtDateRegex.Text = model.DateRegex;
            this.TxtSourceRegex.Text = model.SourceRegex;
            this.TxtContentStart.Text = model.ContentStart;
            this.TxtContentEnd.Text = model.ContentEnd;
            this.TxtRemoveBodyStart.Text = model.RemoveBodyStart;
            this.TxtRemoveBodyEnd.Text = model.RemoveBodyEnd;
            this.TxtNextPageRegex.Text = model.NextPageRegex;
        }
        else
        {
            Response.Write("<script>alert('没有数据');history.back()</script");
        }
    }
    protected void BtnContent_Click(object sender, EventArgs e)//内容
    {
        CollItem_Model.TitleStart = this.TxtTitleStart.Text;
        CollItem_Model.TitleEnd = this.TxtTitleEnd.Text;
        CollItem_Model.KeyWordStart = this.TxtKeyWordStart.Text;
        CollItem_Model.KeyWordEnd = this.TxtKeyWordEnd.Text;
        CollItem_Model.DateRegex = this.TxtDateRegex.Text;
        CollItem_Model.SourceRegex = this.TxtSourceRegex.Text;
        CollItem_Model.ContentStart = this.TxtContentStart.Text;
        CollItem_Model.ContentEnd = this.TxtContentEnd.Text;
        CollItem_Model.RemoveBodyStart = this.TxtRemoveBodyStart.Text;
        CollItem_Model.RemoveBodyEnd = this.TxtRemoveBodyEnd.Text;
        CollItem_Model.NextPageRegex = this.TxtNextPageRegex.Text;
        CollItem_Model.Id = Id;
        if (CollItem_Bll.UpdateContent(CollItem_Model) > 0)
        {
            Response.Write("<script>alert('内容填写完成');window.location='CollItem.aspx?action=test&id=" + Id + "'</script>");
        }
    }
    private bool GetTest(int testType)
    {
        Zxq.Model.CollItem model = CollItem_Bll.GetModel(Id);
        string ListUrl = model.ListUrl;
        string ListStart = model.ListStart;
        string ListEnd = model.ListEnd;
        string LinkStart = model.LinkStart;
        string LinkEnd = model.LinkEnd;
        int IsDesc = model.IsDesc;
        int CollecNum = model.CollecNum;
        string WebUrl = model.WebUrl;
        string WebEncode = model.WebEncode;
        System.Text.Encoding enType = System.Text.Encoding.Default;
        switch (WebEncode)
        {
            case "1":
                enType = System.Text.Encoding.GetEncoding("gb2312");
                break;
            case "2":
                enType = System.Text.Encoding.UTF8;
                break;
            case "3":
                enType = System.Text.Encoding.Unicode;
                break;
        }
        string KeyWordStart = model.KeyWordStart;
        string KeyWordEnd = model.KeyWordEnd;
        string DateRegex = model.DateRegex;
        string SourceRegex = model.SourceRegex;
        string TitleStart = model.TitleStart;
        string TitleEnd = model.TitleEnd;
        string ContentStart = model.ContentStart;
        string ContentEnd = model.ContentEnd;
        string RemoveBodyStart = model.RemoveBodyStart;
        string RemoveBodyEnd = model.RemoveBodyEnd;
        string IsSaveImg = model.IsSaveImg.ToString();
        string NextPageRegex = model.NextPageRegex;
        int Script_Iframe = model.Script_Iframe;
        int Script_A = model.Script_A;
        int Script_Div = model.Script_Div;
        int Script_Font = model.Script_Font;
        int Script_Html = model.Script_Html;
        int Script_Img = model.Script_Img;
        int Script_Object = model.Script_Object;
        int Script_Script = model.Script_Script;
        int Script_Span = model.Script_Span;
        int Script_Table = model.Script_Table;
        int ClassId = model.ClassId;
        string Pic = ConfigurationManager.AppSettings["imgPath"].ToString();
        Zxq.Collection.Collection Cn = new Zxq.Collection.Collection();
        string testList = Cn.GetHttpPageCode(ListUrl, enType);
        if (testList == "$UrlIsFalse")
        {
            Response.Write("<script>alert('列表地址设置错误');window.location='CollItem.aspx?action=list&id=" + Id + "'</script");
            return false;
        }
        if (testList == "$GetFalse")
        {
            Response.Write("<script>alert('无法连接列表页或连接超时');window.location='CollItem.aspx?action=list&id=" + Id + "'</script");
            return false;
        }
        testList = Cn.GetBody(testList, ListStart, ListEnd, true, true);
        if (testList == "$StartFalse")
        {
            Response.Write("<script>alert('列表开始标记设置错误,请重新设置');window.location='CollItem.aspx?action=list&id=" + Id + "'</script");
            return false;
        }
        if (testList == "$EndFalse")
        {
            Response.Write("<script>alert('列表结束标记设置错误,请重新设置');window.location='CollItem.aspx?action=list&id=" + Id + "'</script");
            return false;
        }
        if (testType == 0)
        {
            this.ltListTest.Text = testList;
        }
        else
        {
            ArrayList linkArray = Cn.GetLinkArray(testList, LinkStart, LinkEnd);
            if (linkArray.Count == 0)
            {
                Response.Write("<script>alert('未取到链接,请检查链接设置');window.location='CollItem.aspx?action=link&id=" + Id + "'</script");
                return false;
            }
            else
            {
                if (linkArray[0].ToString() == "$StartFalse")
                {
                    Response.Write("<script>alert('链接开始标记设置错误,请重新设置111');window.location='CollItem.aspx?action=link&id=" + Id + "'</script");
                    return false;
                }
                if (linkArray[0].ToString() == "$EndFalse")
                {
                    Response.Write("<script>alert('链接开始标记设置错误,请重新设置');window.location='CollItem.aspx?action=link&id=" + Id + "'</script");
                    return false;
                }
                if (linkArray[0].ToString() == "$NoneLink")
                {
                    Response.Write("<script>alert('未取到链接,请检查链接设置222');window.location='CollItem.aspx?action=link&id=" + Id + "'</script");
                    return false;
                }
                if (IsDesc == 1)
                {
                    linkArray.Reverse();
                }
                if (CollecNum > 0 && linkArray.Count > CollecNum)
                {
                    linkArray.RemoveRange(CollecNum, linkArray.Count - CollecNum);
                }
                string linkStr = string.Empty;

                if (testType == 1)//链接地址
                {
                    for (int i = 0; i < linkArray.Count; i++)
                    {
                        linkStr = Cn.DefiniteUrl(linkArray[i].ToString(), WebUrl);
                        if (linkStr != "$False")
                        {
                            linkStr = "<a href='" + linkStr + "' target=_blank>" + linkStr + "</a><br>";
                            ltLinkTest.Text += linkStr;
                        }
                    }
                }

                if (testType == 2)//测试
                {
                    linkStr = Cn.DefiniteUrl(linkArray[0].ToString(), WebUrl);
                    if (linkStr == "$False")
                    {
                        Response.Write("<script>alert('获取到的链接地址无效,请检查链接设置');window.location='CollItem.aspx?action=link&id=" + Id + "'</script");
                        return false;
                    }
                    string newsCode = Cn.GetHttpPageCode(linkStr, enType);
                    if (newsCode == "$UrlIsFalse")
                    {
                        Response.Write("<script>alert('获取到的链接地址无效,请检查链接设置');window.location='CollItem.aspx?action=link&id=" + Id + "'</script");
                        return false;
                    }
                    if (newsCode == "$GetFalse")
                    {
                        Response.Write("<script>alert('无法连接内容页或连接超时');window.location='CollItem.aspx?action=content&id=" + Id + "'</script");
                        return false;
                    }
                    string testTitle = Cn.GetBody(newsCode, TitleStart, TitleEnd, false, false);
                    string testKeyWord = Cn.GetBody(newsCode, KeyWordStart, KeyWordEnd, false, false);
                    string testDateTime = Cn.GetRegValue(DateRegex, newsCode);
                    string testSource = Cn.GetRegValue(SourceRegex, newsCode);
                    string testBody = Cn.GetBody(newsCode, ContentStart, ContentEnd, false, false);
                    if (testTitle == "$StartFalse" || testBody == "$StartFalse")
                    {
                        Response.Write("<script>alert('标题或正文开始标记设置错误,请重新设置');window.location='CollItem.aspx?action=content&id=" + Id + "'</script");
                        return false;
                    }
                    if (testTitle == "$EndFalse" || testBody == "$EndFalse")
                    {
                        Response.Write("<script>alert('标题或正文结束标记设置错误,请重新设置');window.location='CollItem.aspx?action=content&id=" + Id + "'</script");
                        return false;
                    }
                    this.ltTestTitle.Text = testTitle;
                    this.ltKeyWord.Text = testKeyWord;
                    this.ltDateTime.Text = testDateTime;
                    this.ltSource.Text = testSource;

                    //------------------获取详细页内容的下一页开始-------------------
                    string NewsNextUrl = Cn.GetRegValue(NextPageRegex, newsCode);
                    int PageCount = 0;
                    while (NewsNextUrl.Length > 0 && PageCount < 20)
                    {
                        string NewsPaingNextCode = string.Empty;
                        string ContentTemp = string.Empty;
                        NewsNextUrl = Cn.DefiniteUrl(NewsNextUrl, WebUrl);
                        NewsPaingNextCode = Cn.GetHttpPageCode(NewsNextUrl, enType);
                        ContentTemp = Cn.GetBody(NewsPaingNextCode, ContentStart, ContentEnd, false, false);
                        testBody = testBody + "<br>$PageNext$<br>" + ContentTemp;
                        string NewsNextUrl_1 = Cn.GetRegValue(NextPageRegex, NewsPaingNextCode);
                        if (NewsNextUrl_1.Length > 0)
                            NewsNextUrl = Cn.DefiniteUrl(NewsNextUrl_1, WebUrl);
                        else
                            break;
                        PageCount++;
                    }
                    //-----------------------获取详细页内容的下一页结束-------------------

                    //-------过滤正文开始-----------------------
                    if (RemoveBodyStart != "" && RemoveBodyEnd != "")
                    {
                        string[] removeBodyStartArr = RemoveBodyStart.Split('$');
                        string[] removeBodyEndArr = RemoveBodyEnd.Split('$');
                        if (removeBodyStartArr.Length > 1 && removeBodyEndArr.Length > 1)
                        {
                            if (removeBodyStartArr.Length != removeBodyEndArr.Length)
                            {
                                Response.Write("<script>alert('少了$请注意');window.location='collitem.aspx'</script");
                                return false;
                            }
                            else
                            {
                                for (int i = 0; i < removeBodyStartArr.Length; i++)
                                {
                                    string remove = Cn.GetBody(testBody, removeBodyStartArr[i], removeBodyEndArr[i], true, true);
                                    testBody = testBody.Replace(remove, "");
                                }
                            }
                        }
                        else
                        {
                            string remove = Cn.GetBody(testBody, RemoveBodyStart, RemoveBodyEnd, true, true);
                            testBody = testBody.Replace(remove, "");
                        }
                    }
                    //--------------过滤正文结束---------------------------

                    ArrayList testBodyArray = Cn.ReplaceSaveRemoteFile(testBody, Pic, WebUrl, "0");
                    ltTestContent.Text = testBodyArray[0].ToString();
                    if (testBodyArray.Count == 2)
                    {
                        ltPhotoUrl.Text = testBodyArray[1].ToString();
                    }
                }

                if (testType == 3)//采集
                {
                    int falseNum = 0;
                    int successNum = 0;
                    SetProcessBar("从" + WebUrl + "采集信息", true);
                    for (int i = 0; i < linkArray.Count; i++)
                    {
                        int isImg = 0;
                        string photoUrl = string.Empty;
                        ProcessBar(i, linkArray.Count);
                        linkStr = Cn.DefiniteUrl(linkArray[i].ToString(), WebUrl);
                        if (linkStr == "$False$")
                        {
                            falseNum++;
                            continue;
                        }
                        string newsPageCode = Cn.GetHttpPageCode(linkStr, enType);
                        if (newsPageCode == "$UrlIsFalse" || newsPageCode == "$GetFalse")
                        {
                            falseNum++;
                            continue;
                        }
                        string cTitle = Cn.GetBody(newsPageCode, TitleStart, TitleEnd, false, false);
                        string cKeyWord = Cn.GetBody(newsPageCode, KeyWordStart, KeyWordEnd, false, false);
                        string cDateTime = Cn.GetRegValue(DateRegex, newsPageCode);
                        string cSource = Cn.GetRegValue(SourceRegex, newsPageCode);
                        string cBody = Cn.GetBody(newsPageCode, ContentStart, ContentEnd, false, false);
                        if (cTitle == "$StartFalse" || cBody == "$StartFalse" || cTitle == "$EndFalse" || cBody == "$EndFalse")
                        {
                            falseNum++;
                            continue;
                        }

                        //--------获取详细页内容的下一页开始---------------
                        string NewsNextUrl = Cn.GetRegValue(NextPageRegex, newsPageCode);
                        int PageCount = 0;
                        while (NewsNextUrl.Length > 0 && PageCount < 20)
                        {
                            string NewsPaingNextCode = string.Empty;
                            string ContentTemp = string.Empty;
                            NewsNextUrl = Cn.DefiniteUrl(NewsNextUrl, WebUrl);
                            NewsPaingNextCode = Cn.GetHttpPageCode(NewsNextUrl, enType);
                            ContentTemp = Cn.GetBody(NewsPaingNextCode, ContentStart, ContentEnd, false, false);
                            cBody = cBody + "<br>$PageNext$<br>" + ContentTemp;
                            string NewsNextUrl_1 = Cn.GetRegValue(NextPageRegex, NewsPaingNextCode);
                            if (NewsNextUrl_1.Length > 0)
                                NewsNextUrl = Cn.DefiniteUrl(NewsNextUrl_1, WebUrl);
                            else
                                break;
                            PageCount++;
                        }
                        //---------获取详细页内容的下一页结束--------------

                        ArrayList bodyArray = Cn.ReplaceSaveRemoteFile(cBody, Pic, WebUrl, IsSaveImg);
                        if (bodyArray.Count == 2)
                        {
                            isImg = 1;
                            photoUrl = bodyArray[1].ToString();
                        }
                        cBody = bodyArray[0].ToString();
                        cBody = cBody.Replace("'", "");

                        //-------过滤正文开始-----------------------
                        if (RemoveBodyStart != "" && RemoveBodyEnd != "")
                        {
                            string[] removeBodyStartArr = RemoveBodyStart.Split('$');
                            string[] removeBodyEndArr = RemoveBodyEnd.Split('$');
                            if (removeBodyStartArr.Length > 1 && removeBodyEndArr.Length > 1)
                            {
                                for (int j = 0; j < removeBodyStartArr.Length; j++)
                                {
                                    string remove = Cn.GetBody(cBody, removeBodyStartArr[j], removeBodyEndArr[j], true, true);
                                    cBody = cBody.Replace(remove, "");
                                }
                            }
                            else
                            {
                                string remove = Cn.GetBody(cBody, RemoveBodyStart, RemoveBodyEnd, true, true);
                                cBody = cBody.Replace(remove, "");
                            }
                        }
                        //--------------过滤正文结束---------------------------


                        //---------------过滤开始--------------------
                        if (Script_Iframe == 1)
                            cBody = Cn.ScriptHtml(cBody, "Iframe", 1);
                        if (Script_Object == 1)
                            cBody = Cn.ScriptHtml(cBody, "Object", 2);
                        if (Script_Script == 1)
                            cBody = Cn.ScriptHtml(cBody, "Script", 2);
                        if (Script_Div == 1)
                            cBody = Cn.ScriptHtml(cBody, "Div", 3);
                        if (Script_Table == 1)
                            cBody = Cn.ScriptHtml(cBody, "Table", 2);
                        if (Script_Span == 1)
                            cBody = Cn.ScriptHtml(cBody, "Span", 3);
                        if (Script_Img == 1)
                            cBody = Cn.ScriptHtml(cBody, "Img", 3);
                        if (Script_Font == 1)
                            cBody = Cn.ScriptHtml(cBody, "Font", 3);
                        if (Script_A == 1)
                            cBody = Cn.ScriptHtml(cBody, "A", 3);
                        if (Script_Html == 1)
                            cBody = Cn.HtmlScript(cBody);
                        //-------------------过滤结束-------------------------------   

                        Zxq.Bll.Collect Collect_Bll = new Zxq.Bll.Collect();
                        Zxq.Model.Collect Collect_Model = new Zxq.Model.Collect();
                        Collect_Model.ClassId = ClassId;
                        Collect_Model.Title = cTitle;
                        Collect_Model.KeyWord = cKeyWord;
                        Collect_Model.DateTime = cDateTime;
                        Collect_Model.Source = cSource;
                        Collect_Model.TxtContent = cBody;
                        Collect_Model.IsImg = isImg;
                        Collect_Model.StrImg = photoUrl;
                        Collect_Bll.Add(Collect_Model);
                        successNum++;
                    }
                    Response.Write("<script>alert('采集完成,成功 " + successNum + "条 ,失败 " + falseNum + "');window.location='Data_Coll.aspx'</script");
                }
            }
        }
        return true;
    }
    protected void SetProcessBar(string tit, bool IsInit)
    {
        if (IsInit)
        {
            string strFileName = Request.PhysicalApplicationPath + "\\progressbar.htm";
            System.IO.StreamReader sr = new System.IO.StreamReader(strFileName, System.Text.Encoding.Default);
            string strHtml = sr.ReadToEnd();
            Response.Write(strHtml);
            sr.Close();
            Response.Flush();
        }
        Response.Write("<script>initPgb('" + tit + "');</script>");
        Response.Flush();
    }
    protected void ProcessBar(int c, int t)
    {
        Response.Write("<script>setPgb(" + ((c + 1) * 100) / t + ");</script>");
        Response.Flush();
    }
    private void GetCollItemList() //列出采集项目
    {
        this.GvCollItemList.DataSource = CollItem_Bll.CollItemList();
        this.GvCollItemList.DataBind();
    }
    protected void GvCollItemList_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        int Id = Convert.ToInt32(GvCollItemList.DataKeys[e.RowIndex].Value);
        CollItem_Bll.Delete(Id);
        GetCollItemList();
    }
}