﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.IO;
using System.Timers;
/// <summary>
///MyServices 的摘要说明
/// </summary>
public class MyServices : Page
{
    public MyServices(string time, HttpContext context)
    {
        StartTime = time;
        _contex = context;
        Runing = false;
        CreateTimer();
    }
    private System.Timers.Timer tService = null;
    public bool Runing;
    public string StartTime;
    public System.Web.HttpContext _contex;

    #region 服务运行入口
    /// <summary>
    /// 服务运行入口
    /// </summary>
    private void Run()
    {
        //执行采集
        this.WriteLog("-------------------开始于" + System.DateTime.Now + "-------------------------\n");
        //处理日志文件大小
        DealWithLogFileSize();

        //处理业务
        RubberAllFile();

        this.WriteLog("-------------------结束于" + DateTime.Now + "-------------------------\n\n\n\n");
    }
    #endregion

    #region 日志文件大小处理
    /// <summary>
    /// 日志文件大小处理
    /// </summary>
    private void DealWithLogFileSize()
    {
        string filePath = System.AppDomain.CurrentDomain.BaseDirectory + @"ServiceWorkLog.txt";
        FileInfo f = new FileInfo(filePath);
        if (f != null && f.Length > 52428800)
        {
            StreamWriter sw = new StreamWriter(filePath, false);
            sw.Write("");
            sw.Close();
            this.WriteLog("文件大小超过有效值，清空日志文件!\n");
        }
        f = null;
    }
    #endregion

    #region 要执行的业务处理部分
    /// <summary>
    /// 要执行的业务处理部分
    /// </summary>
    private void RubberAllFile()
    {
        //this.WriteLog("开始循环采集所有采集项目\n");
        ////首先取得所有的采集项目，然后循环采集
        //foreach (DataRow row1 in new HelpSql().BindGetFile(0, false, 0, 0, "").Tables[0].Rows)
        //{
        //    try
        //    {
        //        this.WriteLog("首先采集项目：" + row1["Name"]);
        //        new StartGet().StartGetFile(Convert.ToInt32(row1["id"].ToString()), _contex);
        //    }
        //    catch (Exception e)
        //    {
        //        this.WriteLog("采集项目\"" + row1["Name"] + "\"过程中出现异常:" + e.Message + "\n");
        //    }
        //}
    }
    #endregion

    #region 记录日志
    /// <summary>
    /// 记录日志
    /// </summary>
    /// <param name="msg"></param>
    private void WriteLog(string msg)
    {
        FileStream fs = new FileStream(System.AppDomain.CurrentDomain.BaseDirectory + @"ServiceWorkLog.txt", FileMode.OpenOrCreate, FileAccess.Write);
        StreamWriter m_streamWriter = new StreamWriter(fs);
        m_streamWriter.BaseStream.Seek(0, SeekOrigin.End);
        m_streamWriter.WriteLine(msg);
        m_streamWriter.Flush();
        fs.Close();
    }
    #endregion

    #region 计时器触发的事件
    /// <summary>
    /// 计时器触发的事件
    /// </summary>
    /// <param name="source"></param>
    /// <param name="e"></param>
    private void OnTimer(Object source, ElapsedEventArgs e)
    {
        tService.Enabled = false;
        Run();
        tService.Enabled = true;
    }
    #endregion

    #region 创建计时器
    /// <summary>
    /// 创建计时器
    /// </summary>
    private void CreateTimer()
    {
        tService = new Timer();
        tService.AutoReset = true;
        tService.Enabled = false;
        tService.Interval = GetTimmerInterval();
        tService.Elapsed += new ElapsedEventHandler(OnTimer);
    }
    #endregion

    #region 获得计时器间隔时间
    /// <summary>
    /// 获得计时器间隔时间
    /// </summary>
    /// <returns></returns>
    private int GetTimmerInterval()
    {
        DateTime dt;
        if (!string.IsNullOrEmpty(StartTime))
        {
            try
            {
                dt = Convert.ToDateTime(StartTime);

                if (dt != null)
                {
                    return dt.Hour * 60 * 60 * 1000 + dt.Minute * 60 * 1000 + dt.Second * 1000 + dt.Millisecond;
                }
                else
                {
                    //默认10分钟一次
                    return 10 * 60 * 1000;
                }
            }
            catch
            {
                //默认10分钟一次
                return 10 * 60 * 1000;
            }
        }
        else
        {
            //默认10分钟一次
            return 10 * 60 * 1000;
        }
    }
    #endregion

    #region 服务命令
    /// <summary>
    /// 开启服务命令
    /// </summary>
    public void Start()
    {
        tService.Enabled = true;
        Runing = true;
    }
    /// <summary>
    /// 关闭服务命令
    /// </summary>
    public void Stop()
    {
        tService.Stop();
        tService.Enabled = false;
        Runing = false;
    }
    #endregion    

}
