﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using MSXML2;
using System.IO;
using System.Text.RegularExpressions;
using System.Text;
using System.Net;
using System.Collections;
using System.Drawing;
/// <summary>
///other 的摘要说明
/// </summary>
public class other
{
	public other()
	{
		//
		//TODO: 在此处添加构造函数逻辑
		//
	}

    #region 日期随机函数
    /// <summary>
    /// 日期随机函数
    /// </summary>
    /// <param name="Style">1是代表年月日小时分钟秒 其他的代表小时分钟秒</param>
    /// <returns></returns>
    public string DateRndName(int Style)
    {
        DateTime d = DateTime.Now;
        Random ra = new Random();
        string s = null, y, m, dd, h, mm, ss;
        y = d.Year.ToString();
        m = d.Month.ToString();
        if (m.Length < 2) m = "0" + m;
        dd = d.Day.ToString();
        if (dd.Length < 2) dd = "0" + dd;
        h = d.Hour.ToString();
        if (h.Length < 2) h = "0" + h;
        mm = d.Minute.ToString();
        if (mm.Length < 2) mm = "0" + mm;
        ss = d.Second.ToString();
        if (ss.Length < 2) ss = "0" + ss;
        if (Style == 1) s += y + m + dd + h + mm + ss;
        else s += h + mm + ss;
        s += ra.Next(100, 999).ToString();
        return s;
    }
    #endregion

    #region 取得文件后缀
    /// <summary>
    /// 取得文件后缀
    /// </summary>
    /// <param name="filename">文件名称</param>
    /// <returns></returns>
    public string GetFileExtends(string filename)
    {
        string ext = null;
        if (filename.IndexOf('.') > 0)
        {
            string[] fs = filename.Split('.');
            ext = fs[fs.Length - 1];
        }
        return ext;
    }
    #endregion

    #region 保存远程文件
    /// <summary>
    /// 保存远程文件
    /// </summary>
    /// <param name="Url">远程url</param>
    /// <param name="Path">保存到的路径</param>        
    public string RemoteSave(string Url, string Path, string FileName)
    {
        try
        {
            Random ra = new Random();
            if (FileName == "")
            {
                FileName = DateRndName(1) + "." + GetFileExtends(Url);
            }
            string StringFilePath = Path + FileName;
            MSXML2.XMLHTTP _xmlhttp = new MSXML2.XMLHTTPClass();
            _xmlhttp.open("GET", Url, false, null, null);
            _xmlhttp.send("");
            if (_xmlhttp.readyState == 4)
            {
                if (_xmlhttp.status == 200)
                {
                    FileStream fs = new FileStream(StringFilePath, FileMode.CreateNew);
                    BinaryWriter w = new BinaryWriter(fs);
                    w.Write((byte[])_xmlhttp.responseBody);
                    w.Close();
                    fs.Close();
                }
                else
                {
                    FileName = null;
                }
            }
            return FileName;
        }
        catch
        {
            return null;
        }
    }
    #endregion

    #region 替换网页中的换行和引号
    /// <summary>
    /// 替换网页中的换行和引号
    /// </summary>
    /// <param name="HtmlCode">HTML源代码</param>
    /// <returns></returns>
    public string ReplaceEnter(string Str)
    {
        Str = Str.Replace(" ", "");
        Str = Str.Replace("\r", "");
        Str = Str.Replace("\n", "");
        Str = Str.Replace("\t", "");
        Str = Str.Replace("\"", "\"\"");
        return Str;
    }
    #endregion

    #region 执行正则提取出值
    /// <summary>
    /// 执行正则提取出值
    /// </summary>
    /// <param name="RegexString">正则表达式</param>
    /// <param name="RemoteStr">HtmlCode源代码</param>
    /// <returns></returns>
    public string GetRegValue(string RegexString, string RemoteStr)
    {
        string MatchVale = "";
        Regex r = new Regex(RegexString,RegexOptions.IgnoreCase);
        Match m = r.Match(RemoteStr);
        if (m.Success)
        {
            MatchVale = m.Value;
        }
        return MatchVale;
    }
    #endregion

    #region  匹配页面的链接
    /// <summary>
    /// 匹配页面的链接
    /// </summary>
    /// <param name="HtmlCode"></param>
    /// <returns></returns>
    public string GetHref(string HtmlCode)
    {
        string MatchVale = "";
        string Reg = @"(h|H)(r|R)(e|E)(f|F) *= *('|"")?((\w|\\|\/|\.|:|-|_)+)[\S]*";
        foreach (Match m in Regex.Matches(HtmlCode, Reg))
        {
            MatchVale += (m.Value).ToLower().Replace("href=", "").Trim() + "|";
        }
        return MatchVale;
    }
    #endregion

    #region 匹配页面的图片地址
    /// <summary>
    /// 匹配页面的图片地址
    /// </summary>
    /// <param name="HtmlCode"></param>
    /// <param name="Url"></param>
    /// <returns></returns>
    public string GetImgSrc(string HtmlCode, string Url)
    {
        string MatchVale = "";
        string Reg = @"<img.*?src=(?:""|')(?<Src>(.*?\.(?:jpg|gif|bmp|png))).*?>";
        foreach (Match m in Regex.Matches(HtmlCode, Reg, RegexOptions.IgnoreCase))
        {
            MatchVale += ConversionUrl(Url, m.Groups["Src"].Value) + "{$$$}";
        }
        return MatchVale;
    }
    #endregion

    #region 根据绝对路径转换相对路径(/)
    /// <summary>
    /// 根据绝对路径转换相对路径(/)
    /// </summary>
    /// <param name="ConsultUrl"></param>
    /// <param name="PrimitiveUrl"></param>
    /// <returns></returns>
    public string ConversionUrl(string ConsultUrl, string PrimitiveUrl)
    {
        ConsultUrl = ConsultUrl.Replace("\\", "/").Trim();
        PrimitiveUrl = PrimitiveUrl.Replace("\"", "").Trim();
        Uri LastConsultUrl = new Uri(ConsultUrl);
        Uri DefiniteUrl = new Uri(LastConsultUrl, PrimitiveUrl, false);
        return DefiniteUrl.ToString();
    }
    #endregion

    #region 提取链接地址
    /// <summary>
    /// 提取链接地址,以$Array$分隔
    /// </summary>
    /// <param name="conStr">原字符串</param>
    /// <param name="startStr">开始字符串</param>
    /// <param name="onverStr">结束字符串</param>
    /// <param name="incluL">是否包含StartStr</param>
    /// <param name="incluR">是否包含OverStr</param>
    /// <returns>链接数组</returns>
    public static string[] GetArray(string conStr, string startStr, string overStr, bool incluL, bool incluR)
    {
        if (string.IsNullOrEmpty(conStr)) return null;
        string regStr = @"(" + startStr + ").+?(" + overStr + ")";
        Regex regex = new Regex(regStr);
        MatchCollection mc = regex.Matches(conStr);
        string[] array = new string[mc.Count];
        int i = 0;
        foreach (Match match in mc)
        {
            array[i] = match.ToString();
            if (!incluL)
            {
                array[i] = array[i].Replace(startStr, "");
            }

            if (!incluR)
            {
                array[i] = array[i].Replace(overStr, "");
            }
            i += 1;
        }
        return array;
    }
    #endregion

    #region 过滤代码中的标签
    ///// <summary>
    ///// 过滤代码中的标签
    ///// </summary>
    ///// <param name="StrContent">代码</param>
    ///// <param name="strRepCode">标签名</param>
    ///// <returns></returns>
    //public static string KillCode(string StrContent, string strRepCode)
    //{
    //    string strRegex = "(<" + strRepCode + ">)|(<" + strRepCode + "(.+?)>)";
    //    Regex reg = new Regex(strRegex, System.Text.RegularExpressions.RegexOptions.IgnoreCase);
    //    Regex reg0 = new Regex(@"</" + strRepCode + ">", System.Text.RegularExpressions.RegexOptions.IgnoreCase);
    //    StrContent = reg.Replace(StrContent, "");
    //    StrContent = reg0.Replace(StrContent, "");
    //    return StrContent;
    //}
    #endregion

    #region 根据正则表达式来截取字段
    ///// <summary>
    ///// 根据正则表达式来截取字段
    ///// </summary>
    ///// <param name="conStr">原字符串</param>
    ///// <param name="startStr">正则开始</param>
    ///// <param name="overStr">正则结束</param>
    ///// <param name="incluL">是否包含startStr</param>
    ///// <param name="incluR">是否包含overStr</param>
    ///// <returns></returns>
    //public  string GetBody(string conStr, string startStr, string overStr, bool incluL, bool incluR)
    //{
    //    if (string.IsNullOrEmpty(conStr)) return "$false";
    //    int start, over;
    //    start = conStr.IndexOf(startStr);
    //    //去掉头部
    //    if (start >= 0)
    //    {
    //        conStr = conStr.Remove(0, start);
    //        if (!incluL)
    //            conStr = conStr.Remove(0, startStr.Length);
    //    }
    //    over = conStr.IndexOf(overStr);
    //    //去掉尾部
    //    if (over >= 0)
    //    {
    //        conStr = conStr.Remove(over + overStr.Length);

    //        if (!incluR)
    //            conStr = conStr.Remove(over);
    //    }
    //    return conStr;
    //}
    #endregion

    #region 获取远程文件源代码
    ///// <summary>
    ///// 获取远程文件源代码
    ///// </summary>
    ///// <param name="url">Url:远程url</param>
    ///// <param name="isUtf">是否是UTF8编码true代表utf-8</param>
    ///// <returns>远程文件源代码</returns>
    //public string GetHttpPage(string url, bool isUtf)
    //{
    //    try
    //    {
    //        string s = "";
    //        MSXML2.XMLHTTP _xmlhttp = new MSXML2.XMLHTTPClass();
    //        _xmlhttp.open("GET", url, false, null, null);
    //        _xmlhttp.send("");
    //        if (_xmlhttp.readyState == 4)
    //        {
    //            if (isUtf)
    //                s = System.Text.Encoding.UTF8.GetString((byte[])_xmlhttp.responseBody);
    //            else
    //                s = System.Text.Encoding.Default.GetString((byte[])_xmlhttp.responseBody);
    //        }
    //        return s;
    //    }
    //    catch (Exception ex)
    //    {
    //        return ex.Message;
    //    }
    //}
    #endregion
}
